#pragma once

#include "NControl.h"
#include "ItemPanel.h"
#include "XMLUtil.h"
#include "MouseEvent.h"
#include "ActionEvent.h"
#include "ScriptletContainerFactory.h"
#include "DataContext.h"

interface NPCOMMONUI_API IItemListener : public IBaseListener
{
public:
	virtual ~IItemListener() {}

	virtual void OnSelect(Item* item) = 0;
	virtual void OnUnselect(Item* item) = 0;
};
class NPCOMMONUI_API CListBox : public CNControl, public IMouseListener
{
public:
	DECLARE_COMPONENT_CREATOR(CListBox);
	CListBox(void);
	virtual ~CListBox(void);

	//override
	LPCTSTR GetClassName() { return SCRIPTLET_LISTBOX_NODE; }
	void OnCreate();
	void SetDataContext(IDataContext* context);

	//operation
	void SetItemTemplate(TiXmlElement* pNode);
	void Select(int index);
	void SelectItem(Item* item);
	int GetSelectedIndex() { return m_defaultSelect; } // [:2008-12-16] GetSelectedIndex Լ߰
	
	void AddItem(IDataContext* datacontext, int index);
	void RemoveItem(int index);
	int AddItem(Item* pItem, IDataContext* datacontext=NULL);
	void RemoveItem(Item* pItem);
	int GetItemCount() { return m_lstData.GetCount(); }
	Item* GetItem(int index); // [:2008-09-10] GetItem Լ ߰
	
	void AddItemListener(IItemListener* itemlistener);
	void RemoveItemListener(IItemListener* IItemListener);
	
	//IMouseListener
	void	OnMousePressed(CMouseEvent* pMouseEvent);
	void	OnMouseReleased(CMouseEvent* pMouseEvent) {}
	void	OnMouseEntered(CMouseEvent* pMouseEvent) {}
	void	OnMouseExited(CMouseEvent* pMouseEvent) {}
	void	OnMouseMoved(CMouseEvent* pMouseEvent) {}
	void	OnMouseWheelMoved(CMouseEvent* pMouseEvent) {}
	
private:
	TiXmlElement* m_ItemTemplateNode;
	CAtlList<Item*> m_lstData;
	CAtlList<IItemListener*> m_lstItemListener;
	int m_defaultSelect;

	BOOL ExistItem(Item* pItem);
	Item* FindItem(int index);
	CContainer* GetItemRoot();
	void FireOnSelect(Item* item);
	void FireOnUnselect(Item* item);
	
};
